//
//  protocolEnums.h
//  BridgeForPhidgets.XC23
//
//  Created by Martin Iliev on 07/10/2020.
//


/* IF YOU ADD/CHANGE ANYTHING HERE DON'T FORGET TO CHANGE THE MANAGERS protocolEnums.h*/

#ifndef protocolEnums_h
#define protocolEnums_h

enum PLUGIN_FUNC
{
    PLUGIN_READ,
    PLUGIN_WRITE,
    PLUGIN_SET,
    PLUGIN_GET,
    PLUGIN_CONNECT,
    PLUGIN_DISCONNECT,
    PLUGIN_SCRIPT_EVENT,
    PLUGIN_SERVER_EVENT
};

enum PLUGIN_FUNC_SELECTOR
{
    RD_INPUT_VALUE,
    RD_INPUT_STATE,
    RD_SENSOR_VALUE,
    RD_SENSOR_RAW_VALUE,
    RD_OUTPUT_STATE,
    RD_TAG,
    RD_MOTOR_POSITION,
    RD_BRIDGE_VALUE,
    RD_VOLTAGE,
    
    RD_PH,
    RD_TEMPERATURE,
    RD_ILLUMINANCE,
    RD_HUMIDITY,
    RD_DB,
    RD_DBA,
    RD_DBC,
    RD_OCTAVES,
    RD_ACCELERATION,
    RD_RESISTANCE,
    RD_ANGULAR_RATE,
    RD_MAGNETIC_FIELD,
    RD_CURRENT,
    RD_TOUCH_VALUE,
    
    WR_OUTPUT_STATE,
    WR_TAG,
    WR_MOTOR_POSITION,
    WR_DISPLAY_STRING,
    WR_VOLTAGE,
    
    SET_RADIOMETRIC,
    SET_ANTENNA_ON,
    SET_LED_ON,
    SET_BACKLIGHT,
    SET_BRIGHTNESS,
    SET_CONTRAST,
    SET_CURSOR_ON,
    SET_CURSOR_BLINK,
    SET_ENABLED,
    SET_GAIN,
    SET_DATA_RATE,
    SET_MOTOR_ON,
    SET_SERVO_MAX,
    SET_SERVO_MIN,
    SET_PORT_MODE,
    SET_CONTROL_MODE,
    SET_ACCELERATION,
    SET_VELOCITY,
    SET_CURRENT_LIMIT,
    SET_CORRECTION_TEMPERATURE,
    SET_BT_NAME,
    
    SET_CHANGE_PH_TRIGGER,
    SET_CHANGE_TEMPERATURE_TRIGGER,
    SET_CHANGE_ILLUMINANCE_TRIGGER,
    SET_ENGAGED,
    SET_MIN_ACCELERATION,
    SET_MAX_ACCELERATION,
    SET_SENSOR_VALUE_CHANGE_TRIGGER,
    SET_VOLTAGE_CHANGE_TRIGGER,
    SET_SCREEN_SIZE,
    SET_ACTIVE_SCREEN,
    SET_CHANGE_HUMIDITY_TRIGGER,
    SET_SPL_CHANGE_TRIGGER,
    SET_CHANGE_RESISTANCE_TRIGGER,
    SET_CHANGE_ACCELERATION_TRIGGER,
    SET_CHANGE_MAGNETIC_FIELD_TRIGGER,
    SET_POWER_SUPPLY,
    SET_CHANGE_CURRENT_TRIGGER,
    SET_CHANGE_TOUCH_VALUE_TRIGGER,
    SET_SENSITIVITY,
    
    GET_ANTENNA_ON,
    GET_LED_ON,
    GET_TAG_PROTOCOL,
    GET_BACKLIGHT,
    GET_BRIGHTNESS,
    GET_CONTRAST,
    GET_NUM_ROWS,
    GET_NUM_COLUMNS,
    GET_CURSOR_ON,
    GET_CURSOR_BLINK,
    GET_ENABLED,
    GET_DATA_RATE_MIN,
    GET_DATA_RATE_MAX,
    GET_DATA_RATE,
    GET_GAIN,
    GET_BRIDGE_MIN,
    GET_BRIDGE_MAX,
    GET_VOLTAGE_MIN,
    GET_VOLTAGE_MAX,
    GET_SERVO_MIN,
    GET_SERVO_MAX,
    GET_ENGAGED,
    GET_ACCELERATION,
    GET_VELOCITY,
    GET_MIN_ACCELERATION,
    GET_MAX_ACCELERATION,
    GET_CONTROL_MODE,
    GET_TARGER_POSITION,
    GET_CURRENT_LIMIT,
    GET_CORRECTION_TEMPERATURE,
    GET_PORT_MODE,
    
    
    GET_MIN_PH,
    GET_MAX_PH,
    GET_CHANGE_PH_TRIGGER,
    GET_MIN_TEMPERATURE,
    GET_MAX_TEMPERATURE,
    GET_CHANGE_TEMPERATURE_TRIGGER,
    GET_MIN_ILLUMINANCE,
    GET_MAX_ILLUMINANCE,
    GET_CHANGE_ILLUMINANCE_TRIGGER,
    
    GET_SENSOR_VALUE_CHANGE_TRIGGER,
    GET_VOLTAGE_CHANGE_TRIGGER,
    GET_ATTACHED_PHIDGETS,
    GET_MIN_HUMIDITY,
    GET_MAX_HUMIDITY,
    GET_CHANGE_HUMIDITY_TRIGGER,
    GET_DB_MAX,
    GET_SPL_CHANGE_TRIGGER,
    GET_MIN_RESISTANCE,
    GET_MAX_RESISTANCE,
    GET_CHANGE_RESISTANCE_TRIGGER,
    GET_CHANGE_ACCELERATION_TRIGGER,
    GET_MAX_ANGULAR_RATE,
    GET_MIN_ANGULAR_RATE,
    GET_MIN_MAGNETIC_FIELD,
    GET_MAX_MAGNETIC_FIELD,
    GET_CHANGE_MAGNETIC_FIELD_TRIGGER,
    GET_MIN_CURRENT,
    GET_MAX_CURRENT,
    GET_POWER_SUPPLY,
    GET_CHANGE_CURRENT_TRIGGER,
    GET_MIN_TOUCH_VALUE,
    GET_MAX_TOUCH_VALUE,
    GET_CHANGE_TOUCH_VALUE_TRIGGER,
    GET_IS_TOUCHED,
    GET_SENSITIVITY,

    SE_ON_ATTACH,
    SE_ON_DETTACH,
    SE_ON_INPUT_CHANGE,
    SE_ON_SENSOR_CHANGE,
    SE_ON_OUTPUT_CHANGE,
    SE_ON_TAG,
    SE_ON_TAG_LOST,
    SE_MOTOR_POS_CHANGE,
    SE_ON_BRIDGE_DATA,
    SE_ON_STEPPER_STOP,
    SE_TIME_EVENT,
    SE_REMOVE,
    SE_UNKNOWN
};

#endif /* protocolEnums_h */
